SystemOrganization addCategory: #TreeMorphTest!

TestCase subclass: #AbstractTreeBrowserTest
	instanceVariableNames: 'browser classWithComments classWithoutComments methodWithComments methodWithoutComments packageWithDocumentation packageWithoutDocumentation packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeMorphTest'!

AbstractTreeBrowserTest subclass: #AbstractCodeBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeMorphTest'!

!AbstractCodeBrowserTest methodsFor: 'class to test' stamp: 'GonzaloMunoz 1/10/2012 18:00'!
classToTest
	self subclassResponsibility! !

!AbstractCodeBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/10/2012 18:34'!
testClassCodeView
	browser
		show;
		onItemClick: classWithComments item.
	self assert: browser viewTextAsString equals: classWithComments item definition! !

!AbstractCodeBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/10/2012 18:34'!
testMethodCodeView
	browser
		show;
		onItemClick: methodWithComments item.
	self assert: browser viewTextAsString equals: methodWithComments item getSource! !

!AbstractCodeBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/10/2012 18:34'!
testPackageCodeView
	browser
		show;
		onItemClick: packageWithDocumentation item.
	self assert: browser viewTextAsString equals: ''! !

AbstractCodeBrowserTest subclass: #CodeBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeMorphTest'!

!CodeBrowserTest methodsFor: 'class to test' stamp: 'GonzaloMunoz 1/10/2012 18:32'!
classToTest
	^ CodeBrowser! !

AbstractTreeBrowserTest subclass: #AbstractDocumentationBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeMorphTest'!

!AbstractDocumentationBrowserTest methodsFor: 'class to test' stamp: 'GonzaloMunoz 1/10/2012 18:01'!
classToTest
	self subclassResponsibility! !

!AbstractDocumentationBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/10/2012 18:35'!
testClassDocumentationView
	browser
		show;
		onItemClick: classWithComments item.
	self assert: browser viewTextAsString equals: classWithComments item comment.
	browser onItemClick: classWithoutComments item.
	self assert: browser viewTextAsString equals: 'PAS DE COMMENTAIRES'! !

!AbstractDocumentationBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/10/2012 18:35'!
testMethodDocumentationView
	browser
		show;
		onItemClick: methodWithComments item.
	self assert: browser viewTextAsString equals: methodWithComments item comment.
	browser onItemClick: methodWithoutComments item.
	self assert: browser viewTextAsString equals: 'PAS DE COMMENTAIRES'! !

!AbstractDocumentationBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/10/2012 18:35'!
testOnItemClickNil
	super testOnItemClickNil! !

!AbstractDocumentationBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/10/2012 18:35'!
testPackageDocumentationView
	browser
		show;
		onItemClick: packageWithDocumentation item.
	self assert: browser viewTextAsString equals: (browser documentationForPackage: packageWithDocumentation item).
	browser onItemClick: packageWithoutDocumentation item.
	self assert: browser viewTextAsString equals: ''! !

AbstractDocumentationBrowserTest subclass: #TreeBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeMorphTest'!

!TreeBrowserTest methodsFor: 'class to test' stamp: 'GonzaloMunoz 1/10/2012 18:03'!
classToTest
	^ TreeBrowser! !

!AbstractTreeBrowserTest methodsFor: 'class to test' stamp: 'GonzaloMunoz 1/2/2012 14:32'!
classToTest
	self subclassResponsibility.! !

!AbstractTreeBrowserTest methodsFor: 'bugfinder' stamp: 'GonzaloMunoz 1/8/2012 23:11'!
runBugFinder
	browser := self classToTest new
		show;
		yourself.
	^ BugFinder tryUnarySelectors: browser iterations: 100! !

!AbstractTreeBrowserTest methodsFor: 'running' stamp: 'GonzaloMunoz 1/10/2012 17:46'!
setUp
	browser := self classToTest new.
	packages := PackageOrganizer default packages
		collect: [ :aPackageInfo | PackageInfoListItemWrapper with: aPackageInfo ].
	packageWithDocumentation := packages
		detect: [ :packageListItem | packageListItem contents anySatisfy: [ :classListItem | classListItem item hasComment ] ].
	packageWithoutDocumentation := packages
		detect: [ :packageListItem | packageListItem contents allSatisfy: [ :classListItem | classListItem item hasComment not ] ].
	classWithComments := packageWithDocumentation contents detect: [ :classListItem | classListItem item hasComment ].
	classWithoutComments := packageWithoutDocumentation contents
		detect: [ :classListItem | classListItem item hasComment not ].
	packages
		anySatisfy: [ :packageListItem | 
			packageListItem contents
				anySatisfy: [ :classListItem | 
					classListItem contents
						anySatisfy: [ :methodListItem | 
							methodListItem item comment notNil
								ifTrue: [ methodWithComments := methodListItem ].
							methodListItem item comment notNil ] ] ].
	packages
		anySatisfy: [ :packageListItem | 
			packageListItem contents
				anySatisfy: [ :classListItem | 
					classListItem contents
						anySatisfy: [ :methodListItem | 
							methodListItem item comment isNil
								ifTrue: [ methodWithoutComments := methodListItem ].
							methodListItem item comment isNil ] ] ]! !

!AbstractTreeBrowserTest methodsFor: 'running' stamp: 'GonzaloMunoz 1/10/2012 17:49'!
tearDown
	browser := nil.
	packages := nil.
	packageWithDocumentation := nil.
	packageWithoutDocumentation := nil.
	classWithComments := nil.
	classWithoutComments := nil.
	methodWithComments := nil.
	methodWithoutComments := nil.
	super tearDown! !

!AbstractTreeBrowserTest methodsFor: 'tests' stamp: 'GonzaloMunoz 1/8/2012 22:32'!
testOnItemClickNil
	self shouldnt: [ browser onItemClick: nil ] raise: MessageNotUnderstood.! !
